/*************************************************************************
       > File Name: sm3test.c
       > Author:NEWPLAN
       > E-mail:newplan001@163.com
       > Created Time: Thu Apr 13 23:55:50 2017
************************************************************************/
#include <string.h>
#include <stdio.h>
#include "sm3.h"



int sm3_test( unsigned char* input, int ilen, unsigned char* output, int flag )
{
	int i;

  sm3(input, ilen, output);
  
  if(flag ){
    printf("Message:\n\r");
    for (i = 0; i < ilen; i++)
    {
      printf("%02x", input[i]);
      if (((i + 1) % 4 ) == 0) printf(" ");
    }

   
    printf("Hash:\n\r   ");
    
    for (i = 0; i < 32; i++)
    {
      printf("%02x", output[i]);
      if (((i + 1) % 4 ) == 0) printf(" ");
    }
    printf("\n\r");
  }
  
#if 0
	printf("Message:\n\r");
	for (i = 0; i < 16; i++)
		printf("abcd");
	printf("\n\r");

	sm3_starts( &ctx );
	for (i = 0; i < 16; i++)
		sm3_update( &ctx, "abcd", 4 );
	sm3_finish( &ctx, output );
	memset( &ctx, 0, sizeof( sm3_context ) );

	printf("Hash:\n\r   ");
	for (i = 0; i < 32; i++)
	{
		printf("%02x", output[i]);
		if (((i + 1) % 4 ) == 0) printf(" ");
	}
	printf("\n\r");
#endif  
  return 0;
	//getch();	//VS2008
}
